/****************************/
/* PHANTASIE ϊvO */
/****************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXBYTE		65535
#define	MAXPROG		0x2000
#define	S_LEN		128

#define	LETTER_ST	0x0460
#define	LETTER_ED	0x0635+1

#define	BOXFULL_ST	0x063f
#define	BOXFULL_ED	0x0a42+1

#define	CHARA_ST	0x0b6e
#define	CHARA_ED	0x0f07+1

#define	DISKDRAW_ST	0x137b
#define	DISKDRAW_ED	0x1595+1

#define	DISPMAP_ST	0x0f18
#define	DISPMAP_ED	0x1281+1

#define	BEEP_ST		0x4859-0x4000
#define	BEEP_ED		0x4895-0x4000+1

#define	PATCHNUM	6

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;

	typedef struct {
		FILE	*infp;
		char	fname[S_LEN];
		unsigned char	data[MAXPROG];
		int		st;
		int		ed;
		int		mode;
	} patch_t;

	patch_t patch[PATCHNUM];

	unsigned char	buff[MAXBYTE];

	char	fname[S_LEN];

	int		progno;
	int		flen;

	int		c,i,j,k;
	int		stadd,ptno;

	if (argc != 2) {
		fprintf(stderr, "Usage: convp6ph1 program-no. \n");
		exit(1);
	}

	progno = atoi(argv[1]);

	if (progno < 0 || progno > 8) {
		printf("Program number error\n");
		exit(1);
	}

/* parameter set */

	patch[0].st = BOXFULL_ST;
	patch[0].ed = BOXFULL_ED;
	strcpy(patch[0].fname,"boxfull_p6.bin");
	patch[0].mode = 0;

	patch[1].st = CHARA_ST;
	patch[1].ed = CHARA_ED;
	strcpy(patch[1].fname,"dispchara_p6.bin");
	patch[1].mode = 0;

	patch[2].st = LETTER_ST;
	patch[2].ed = LETTER_ED;
	strcpy(patch[2].fname,"displetter_p6.bin");
	patch[2].mode = 0;

	patch[3].st = DISKDRAW_ST;
	patch[3].ed = DISKDRAW_ED;
	strcpy(patch[3].fname,"diskdraw_p6.bin");
	patch[3].mode = 0;

	patch[4].st = DISPMAP_ST;
	patch[4].ed = DISPMAP_ED;
	strcpy(patch[4].fname,"dispmap_p6.bin");
	patch[4].mode = 0;

	patch[5].st = BEEP_ST;
	patch[5].ed = BEEP_ED;
	strcpy(patch[5].fname,"beep_p6.bin");
	patch[5].mode = 1;


/* open files */

	sprintf(fname,"prog%d.bin",progno);
	if ((infp = fopen(fname, "rb")) == NULL) {
		perror(fname);
		exit(1);
	}

	sprintf(fname,"prog%d_p6.bin",progno);
	if ((outfp = fopen(fname, "wb")) == NULL) {
		perror(fname);
		exit(1);
	}

	for (i = 0;i < PATCHNUM;i ++) {
		if ((patch[i].infp = fopen(patch[i].fname, "rb")) == NULL) {
			perror(patch[i].fname);
			exit(1);
		}
	}


/* t@Cǂݏo */
	i = 0x100;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	flen = i;


	for (i = 0;i < PATCHNUM;i ++) {
		k = patch[i].st;
		while ( (c = fgetc(patch[i].infp)) != EOF) {
			patch[i].data[k] = c;
			k ++;
		}
		if (k != patch[i].ed) {
			printf("%s length error\n",patch[i].fname);
			exit(1);
		}
	}

/***************************************************************/
/* vO#8iGAME OVERj̃o[WɂZN^C */
/***************************************************************/

	if (progno == 8) {

		if (buff[0x400] == 0xc3 && buff[0x401] == 0xb8 && buff[0x402] == 0x39) {
			for (i = 0x300;i < flen;i ++) {
				buff[i-0x300] = buff[i];
			}
		} else if (buff[0x100] == 0xc3 && buff[0x101] == 0xb8 && buff[0x102] == 0x39) {
			;
		} else {
			printf("version illigal:PROGRAM NO.%d\n",progno);
			exit(1);
		}
		flen -= 0x300;
	}

/********************************/
/********** ʂ̕ϊ **********/
/********************************/
/* FILE READ/WRITE */
	buff[0x0400] = buff[0x0100];
	buff[0x0401] = buff[0x0101];
	buff[0x0402] = buff[0x0102];
	for (i = 0x0100;i < 0x03ff;i ++) {
		buff[i] = 0xff;
	}

	for (i = 0;i < PATCHNUM;i ++) {
		if (patch[i].mode == 0) {
			for (k = patch[i].st;k < patch[i].ed;k ++) {
				buff[k] = patch[i].data[k];
			}
		}
	}


/********************************/
/********** ʂ̕ϊ **********/
/********************************/

	switch (progno) {
		case 0:	/* vO#0iQ[Nj */
				/* 04:00:01:01 */
			buff[0x366e] = 0xc3; /* L[ */
			buff[0x366f] = 0xa0; /* L[ */
			buff[0x3670] = 0x00; /* L[ */
			buff[0x3d88] = 0xf3; /* di  */
			buff[0x3d89] = 0x00; /* nop */
			buff[0x3d8d] = 0xfb; /* ei  */

//			buff[0x39be] = 0x05; /* ^CO ftHgl */
			buff[0x220e] = 0x00; /* ^COύX  */
			buff[0x220f] = 0x04; /* ^COύX  */

			break;

		case 1:	/* vO#1iTOWNj */
				/* 1C:00:01:01 */
			buff[0x366e] = 0xc3; /* L[ */
			buff[0x366f] = 0xa0; /* L[ */
			buff[0x3670] = 0x00; /* L[ */
			buff[0x6c05] = 0xf3; /* di  */
			buff[0x6c06] = 0x00; /* nop */
			buff[0x6c0a] = 0xfb; /* ei  */

			buff[0x220e] = 0x00; /* ^COύX  */
			buff[0x220f] = 0x04; /* ^COύX  */

			break;

		case 2:	/* vO#2itB[hj */
				/* 06:00:07:01 */
			buff[0x369a] = 0xc3; /* L[ */
			buff[0x369b] = 0xa0; /* L[ */
			buff[0x369c] = 0x00; /* L[ */
			buff[0x5b4f] = 0xf3; /* di  */
			buff[0x5b50] = 0x00; /* nop */
			buff[0x5b54] = 0xfb; /* ei  */

			stadd = 0x4859;
			ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x227e] = 0x00; /* ^COύX  */
			buff[0x227f] = 0x08; /* ^COύX  */

			break;

		case 3:	/* vO#3i_Wj */
				/* 1A:00:01:01 */
			buff[0x35a5] = 0xc3; /* L[ */
			buff[0x35a6] = 0xa0; /* L[ */
			buff[0x35a7] = 0x00; /* L[ */
			buff[0x5d2c] = 0xf3; /* di  */
			buff[0x5d2d] = 0x00; /* nop */
			buff[0x5d31] = 0xfb; /* ei  */

			stadd = 0x424c;
			ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x227e] = 0x00; /* ^COύX  */
			buff[0x227f] = 0x08; /* ^COύX  */

			break;

		case 4:	/* vO#4iGUILDj */
				/* 1D:00:06:01 */

			if (buff[0x3aa4] == 0xcd && buff[0x3aa5] == 0x2e && buff[0x3aa6] == 0x37) {
				buff[0x3aa4] = 0xcd; /* L[ */
				buff[0x3aa5] = 0xa0; /* L[ */
				buff[0x3aa6] = 0x00; /* L[ */
			} else if (buff[0x37d4] == 0xcd && buff[0x37d5] == 0x6e && buff[0x37d6] == 0x36) {
				buff[0x37d4] = 0xcd; /* L[ */
				buff[0x37d5] = 0xa0; /* L[ */
				buff[0x37d6] = 0x00; /* L[ */
			} else {
				printf("version illigal:PROGRAM NO.%d\n",progno);
				exit(1);
			}

			if (buff[0x5ee2] == 0xd3 && buff[0x5ee3] == 0xe6) {
				buff[0x5ee2] = 0xf3; /* di  */
				buff[0x5ee3] = 0x00; /* nop */
				buff[0x5ee7] = 0xfb; /* ei  */
			} else if (buff[0x5ee2-0x2d0] == 0xd3 && buff[0x5ee3-0x2d0] == 0xe6) {
				buff[0x5ee2-0x2d0] = 0xf3; /* di  */
				buff[0x5ee3-0x2d0] = 0x00; /* nop */
				buff[0x5ee7-0x2d0] = 0xfb; /* ei  */
			} else {
				printf("version illigal:PROGRAM NO.%d\n",progno);
				exit(1);
			}

			buff[0x220e] = 0x00; /* ^COύX  */
			buff[0x220f] = 0x04; /* ^COύX  */

			break;

		case 5:	/* vO#5iARMORYj */
				/* 09:00:0B:01 */
			buff[0x366e] = 0xc3; /* L[ */
			buff[0x366f] = 0xa0; /* L[ */
			buff[0x3670] = 0x00; /* L[ */

			if (buff[0x42a2] == 0xd3 && buff[0x42a3] == 0xe6) {
				buff[0x42a2] = 0xf3; /* di  */
				buff[0x42a3] = 0x00; /* nop */
				buff[0x42a7] = 0xfb; /* ei  */
			} else if (buff[0x42a2-0x11] == 0xd3 && buff[0x42a3-0x11] == 0xe6) {
				buff[0x42a2-0x11] = 0xf3; /* di  */
				buff[0x42a3-0x11] = 0x00; /* nop */
				buff[0x42a7-0x11] = 0xfb; /* ei  */
			} else {
				printf("version illigal:PROGRAM NO.%d\n",progno);
				exit(1);
			}

			buff[0x220e] = 0x00; /* ^COύX  */
			buff[0x220f] = 0x04; /* ^COύX  */

			break;

		case 6:	/* vO#6iX^[j */
				/* 0E:00:0D:01 */
			buff[0x27ae] = 0xc3; /* L[ */
			buff[0x27af] = 0xa0; /* L[ */
			buff[0x27b0] = 0x00; /* L[ */

			if (buff[0x7869] == 0xd3 && buff[0x786a] == 0xe6) {
				buff[0x7869] = 0xf3; /* di  */
				buff[0x786a] = 0x00; /* nop */
				buff[0x786e] = 0xfb; /* ei  */
			} else if (buff[0x7869-0x29] == 0xd3 && buff[0x786a-0x29] == 0xe6) {
				buff[0x7869-0x29] = 0xf3; /* di  */
				buff[0x786a-0x29] = 0x00; /* nop */
				buff[0x786e-0x29] = 0xfb; /* ei  */
			} else {
				printf("version illigal:PROGRAM NO.%d\n",progno);
				exit(1);
			}

			stadd = 0x5e53;
			ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x222b] = 0x00; /* ^COύX  */
			buff[0x222c] = 0x04; /* ^COύX  */

			break;

		case 7:	/* vO#7iCOMMANDj */
				/* 0B:01:06:01 */
			buff[0x376a] = 0xc3; /* L[ */
			buff[0x376b] = 0xa0; /* L[ */
			buff[0x376c] = 0x00; /* L[ */
			buff[0x4f1b] = 0xf3; /* di  */
			buff[0x4f1c] = 0x00; /* nop */
			buff[0x4f20] = 0xfb; /* ei  */

			buff[0x417c] = 0x15; /* bug fix */
			buff[0x417f] = 0x15; /* bug fix */
			buff[0x4198] = 0x15; /* bug fix */
			buff[0x2344] = 0x00; /* ^COύX  */
			buff[0x2344] = 0x04; /* ^COύX  */

			break;

		case 8:	/* vO#8iGAME OVERj */
				/* 20:00:0D:01 */
			buff[0x2ba6] = 0xc3; /* L[ */
			buff[0x2ba7] = 0xa0; /* L[ */
			buff[0x2ba8] = 0x00; /* L[ */

			stadd = 0x3526;
			ptno = 5;
			for (i = patch[ptno].st;i < patch[ptno].ed;i ++) {
				buff[stadd + i - patch[ptno].st] = patch[ptno].data[i];
			}

			buff[0x36f2] = 0x00; /* bug fix */
			buff[0x3874] = 0x00; /* bug fix */
			buff[0x39d4] = 0xdc; /* bug fix */

			buff[0x39b9] = 0xf3; /* di  */
			buff[0x39ba] = 0x00; /* nop */
			buff[0x39be] = 0xfb; /* ei  */

			buff[0x2200] = 0x00; /* ^COύX  */
			buff[0x2201] = 0x04; /* ^COύX  */

			break;

		default:
			break;
	}



/* t@C */
	for (i = 0x100;i < flen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(outfp);
	fclose(infp);


	return(0);
}
